diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/he/he-frame-exchange-manager.cc ns-3.38/src/wifi/model/he/he-frame-exchange-manager.cc
--- ns-3.37/src/wifi/model/he/he-frame-exchange-manager.cc	2022-11-01 17:37:24.743395800 -0700
+++ ns-3.38/src/wifi/model/he/he-frame-exchange-manager.cc	2023-03-16 20:54:23.856869200 -0700
@@ -25,10 +25,13 @@
 
 #include "ns3/abort.h"
 #include "ns3/ap-wifi-mac.h"
+#include "ns3/erp-ofdm-phy.h"
 #include "ns3/log.h"
 #include "ns3/recipient-block-ack-agreement.h"
 #include "ns3/snr-tag.h"
 #include "ns3/sta-wifi-mac.h"
+#include "ns3/wifi-mac-queue.h"
+#include "ns3/wifi-mac-trailer.h"
 
 #include <algorithm>
 #include <functional>
@@ -43,6 +46,14 @@
 
 NS_OBJECT_ENSURE_REGISTERED(HeFrameExchangeManager);
 
+bool
+IsTrigger(const WifiPsduMap& psduMap)
+{
+    return psduMap.size() == 1 && psduMap.cbegin()->first == SU_STA_ID &&
+           psduMap.cbegin()->second->GetNMpdus() == 1 &&
+           psduMap.cbegin()->second->GetHeader(0).IsTrigger();
+}
+
 TypeId
 HeFrameExchangeManager::GetTypeId()
 {
@@ -54,7 +65,8 @@
 }
 
 HeFrameExchangeManager::HeFrameExchangeManager()
-    : m_triggerFrameInAmpdu(false)
+    : m_intraBssNavEnd(0),
+      m_triggerFrameInAmpdu(false)
 {
     NS_LOG_FUNCTION(this);
 }
@@ -64,6 +76,18 @@
     NS_LOG_FUNCTION_NOARGS();
 }
 
+void
+HeFrameExchangeManager::Reset()
+{
+    NS_LOG_FUNCTION(this);
+    if (m_intraBssNavResetEvent.IsRunning())
+    {
+        m_intraBssNavResetEvent.Cancel();
+    }
+    m_intraBssNavEnd = Simulator::Now();
+    VhtFrameExchangeManager::Reset();
+}
+
 uint16_t
 HeFrameExchangeManager::GetSupportedBaBufferSize() const
 {
@@ -84,6 +108,18 @@
 }
 
 void
+HeFrameExchangeManager::SetWifiPhy(const Ptr<WifiPhy> phy)
+{
+    NS_LOG_FUNCTION(this << phy);
+    VhtFrameExchangeManager::SetWifiPhy(phy);
+    // Cancel intra-BSS NAV reset timer when receiving a frame from the PHY
+    phy->TraceConnectWithoutContext("PhyRxPayloadBegin",
+                                    Callback<void, WifiTxVector, Time>([this](WifiTxVector, Time) {
+                                        m_intraBssNavResetEvent.Cancel();
+                                    }));
+}
+
+void
 HeFrameExchangeManager::DoDispose()
 {
     NS_LOG_FUNCTION(this);
@@ -122,14 +158,17 @@
      *   or the next frame in the AC queue is a non-broadcast QoS data frame addressed to
      *   a receiver with which a BA agreement has been already established
      */
-    if (m_muScheduler && !edca->GetBaManager()->GetBar(false) &&
+    if (m_muScheduler && !GetBar(edca->GetAccessCategory()) &&
         (!(mpdu = edca->PeekNextMpdu(m_linkId)) ||
          (mpdu->GetHeader().IsQosData() && !mpdu->GetHeader().GetAddr1().IsGroup() &&
-          edca->GetBaAgreementEstablished(mpdu->GetHeader().GetAddr1(),
-                                          mpdu->GetHeader().GetQosTid()))))
+          m_mac->GetBaAgreementEstablishedAsOriginator(mpdu->GetHeader().GetAddr1(),
+                                                       mpdu->GetHeader().GetQosTid()))))
     {
-        txFormat =
-            m_muScheduler->NotifyAccessGranted(edca, availableTime, initialFrame, m_allowedWidth);
+        txFormat = m_muScheduler->NotifyAccessGranted(edca,
+                                                      availableTime,
+                                                      initialFrame,
+                                                      m_allowedWidth,
+                                                      m_linkId);
     }
 
     if (txFormat == MultiUserScheduler::SU_TX)
@@ -139,27 +178,28 @@
 
     if (txFormat == MultiUserScheduler::DL_MU_TX)
     {
-        if (m_muScheduler->GetDlMuInfo().psduMap.empty())
+        if (m_muScheduler->GetDlMuInfo(m_linkId).psduMap.empty())
         {
             NS_LOG_DEBUG(
                 "The Multi-user Scheduler returned DL_MU_TX with empty psduMap, do not transmit");
             return false;
         }
 
-        SendPsduMapWithProtection(m_muScheduler->GetDlMuInfo().psduMap,
-                                  m_muScheduler->GetDlMuInfo().txParams);
+        SendPsduMapWithProtection(m_muScheduler->GetDlMuInfo(m_linkId).psduMap,
+                                  m_muScheduler->GetDlMuInfo(m_linkId).txParams);
         return true;
     }
 
     if (txFormat == MultiUserScheduler::UL_MU_TX)
     {
         auto packet = Create<Packet>();
-        packet->AddHeader(m_muScheduler->GetUlMuInfo().trigger);
-        auto trigger = Create<WifiMpdu>(packet, m_muScheduler->GetUlMuInfo().macHdr);
+        packet->AddHeader(m_muScheduler->GetUlMuInfo(m_linkId).trigger);
+        auto trigger = Create<WifiMpdu>(packet, m_muScheduler->GetUlMuInfo(m_linkId).macHdr);
         SendPsduMapWithProtection(
-            WifiPsduMap{{SU_STA_ID,
-                         GetWifiPsdu(trigger, m_muScheduler->GetUlMuInfo().txParams.m_txVector)}},
-            m_muScheduler->GetUlMuInfo().txParams);
+            WifiPsduMap{
+                {SU_STA_ID,
+                 GetWifiPsdu(trigger, m_muScheduler->GetUlMuInfo(m_linkId).txParams.m_txVector)}},
+            m_muScheduler->GetUlMuInfo(m_linkId).txParams);
         return true;
     }
 
@@ -167,29 +207,20 @@
 }
 
 bool
-HeFrameExchangeManager::SendMpduFromBaManager(Ptr<QosTxop> edca,
+HeFrameExchangeManager::SendMpduFromBaManager(Ptr<WifiMpdu> mpdu,
                                               Time availableTime,
                                               bool initialFrame)
 {
-    NS_LOG_FUNCTION(this << edca << availableTime << initialFrame);
-
-    // First, check if there is a BAR to be transmitted
-    Ptr<const WifiMpdu> peekedItem = edca->GetBaManager()->GetBar(false);
-
-    if (!peekedItem)
-    {
-        NS_LOG_DEBUG("Block Ack Manager returned no frame to send");
-        return false;
-    }
+    NS_LOG_FUNCTION(this << *mpdu << availableTime << initialFrame);
 
-    if (peekedItem->GetHeader().IsBlockAckReq())
+    // First, check if there is a Trigger Frame to be transmitted
+    if (!mpdu->GetHeader().IsTrigger())
     {
         // BlockAckReq are handled by the HT FEM
-        return HtFrameExchangeManager::SendMpduFromBaManager(edca, availableTime, initialFrame);
+        return HtFrameExchangeManager::SendMpduFromBaManager(mpdu, availableTime, initialFrame);
     }
 
-    NS_ASSERT(peekedItem->GetHeader().IsTrigger());
-    m_triggerFrame = Copy(edca->GetBaManager()->GetBar());
+    m_triggerFrame = mpdu;
 
     SendPsduMap();
     return true;
@@ -203,22 +234,6 @@
     m_psduMap = std::move(psduMap);
     m_txParams = std::move(txParams);
 
-#ifdef NS3_BUILD_PROFILE_DEBUG
-    // If protection is required, the MPDUs must be stored in some queue because
-    // they are not put back in a queue if the MU-RTS/CTS exchange fails
-    if (m_txParams.m_protection->method != WifiProtection::NONE)
-    {
-        for (const auto& psdu : psduMap)
-        {
-            for (const auto& mpdu : *PeekPointer(psdu.second))
-            {
-                NS_ASSERT(mpdu->GetHeader().IsCtl() || !mpdu->GetHeader().HasData() ||
-                          mpdu->IsQueued());
-            }
-        }
-    }
-#endif
-
     // Make sure that the acknowledgment time has been computed, so that SendMuRts()
     // can reuse this value.
     NS_ASSERT(m_txParams.m_acknowledgment);
@@ -228,17 +243,54 @@
         CalculateAcknowledgmentTime(m_txParams.m_acknowledgment.get());
     }
 
+    // in case we are sending a Trigger Frame, update the acknowledgment time so that
+    // the Duration/ID of the MU-RTS is correctly computed
+    if (!m_txParams.m_txVector.IsUlMu() && IsTrigger(m_psduMap))
+    {
+        NS_ASSERT(m_muScheduler);
+        const auto& trigger = m_muScheduler->GetUlMuInfo(m_linkId).trigger;
+        NS_ASSERT_MSG(!trigger.IsBasic() || m_txParams.m_acknowledgment->method ==
+                                                WifiAcknowledgment::UL_MU_MULTI_STA_BA,
+                      "Acknowledgment (" << m_txParams.m_acknowledgment.get()
+                                         << ") incompatible with Basic Trigger Frame");
+        NS_ASSERT_MSG(!trigger.IsBsrp() ||
+                          m_txParams.m_acknowledgment->method == WifiAcknowledgment::NONE,
+                      "Acknowledgment (" << m_txParams.m_acknowledgment.get()
+                                         << ") incompatible with BSRP Trigger Frame");
+        // Add a SIFS and the TB PPDU duration to the acknowledgment time of the Trigger Frame
+        auto txVector = trigger.GetHeTbTxVector(trigger.begin()->GetAid12());
+        m_txParams.m_acknowledgment->acknowledgmentTime +=
+            m_phy->GetSifs() + HePhy::ConvertLSigLengthToHeTbPpduDuration(trigger.GetUlLength(),
+                                                                          txVector,
+                                                                          m_phy->GetPhyBand());
+    }
+
     // Set QoS Ack policy
     for (auto& psdu : m_psduMap)
     {
         WifiAckManager::SetQosAckPolicy(psdu.second, m_txParams.m_acknowledgment.get());
     }
 
+    for (const auto& psdu : m_psduMap)
+    {
+        for (const auto& mpdu : *PeekPointer(psdu.second))
+        {
+            if (mpdu->IsQueued())
+            {
+                mpdu->SetInFlight(m_linkId);
+            }
+        }
+    }
+
     if (m_txParams.m_protection->method == WifiProtection::RTS_CTS)
     {
         NS_ABORT_MSG_IF(m_psduMap.size() > 1, "Cannot use RTS/CTS with MU PPDUs");
         SendRts(m_txParams);
     }
+    else if (m_txParams.m_protection->method == WifiProtection::MU_RTS_CTS)
+    {
+        SendMuRts(m_txParams);
+    }
     else if (m_txParams.m_protection->method == WifiProtection::NONE)
     {
         SendPsduMap();
@@ -249,6 +301,145 @@
     }
 }
 
+Time
+HeFrameExchangeManager::GetMuRtsDurationId(uint32_t muRtsSize,
+                                           const WifiTxVector& muRtsTxVector,
+                                           Time txDuration,
+                                           Time response) const
+{
+    NS_LOG_FUNCTION(this << muRtsSize << muRtsTxVector << txDuration << response);
+
+    if (m_edca->GetTxopLimit(m_linkId).IsZero())
+    {
+        WifiTxVector txVector;
+        txVector.SetMode(GetCtsModeAfterMuRts());
+        return VhtFrameExchangeManager::GetRtsDurationId(txVector, txDuration, response);
+    }
+
+    // under multiple protection settings, if the TXOP limit is not null, Duration/ID
+    // is set to cover the remaining TXOP time (Sec. 9.2.5.2 of 802.11-2016).
+    // The TXOP holder may exceed the TXOP limit in some situations (Sec. 10.22.2.8
+    // of 802.11-2016)
+    return std::max(m_edca->GetRemainingTxop(m_linkId) -
+                        m_phy->CalculateTxDuration(muRtsSize, muRtsTxVector, m_phy->GetPhyBand()),
+                    Seconds(0));
+}
+
+void
+HeFrameExchangeManager::SendMuRts(const WifiTxParameters& txParams)
+{
+    NS_LOG_FUNCTION(this << &txParams);
+    WifiMacHeader hdr;
+    hdr.SetType(WIFI_MAC_CTL_TRIGGER);
+    hdr.SetAddr1(Mac48Address::GetBroadcast());
+    hdr.SetAddr2(m_self);
+    hdr.SetDsNotTo();
+    hdr.SetDsNotFrom();
+    hdr.SetNoRetry();
+    hdr.SetNoMoreFragments();
+
+    NS_ASSERT(txParams.m_protection && txParams.m_protection->method == WifiProtection::MU_RTS_CTS);
+    WifiMuRtsCtsProtection* protection =
+        static_cast<WifiMuRtsCtsProtection*>(txParams.m_protection.get());
+
+    NS_ASSERT(protection->muRts.IsMuRts());
+    protection->muRts.SetCsRequired(true);
+    Ptr<Packet> payload = Create<Packet>();
+    payload->AddHeader(protection->muRts);
+
+    auto mpdu = Create<WifiMpdu>(payload, hdr);
+
+    NS_ASSERT(txParams.m_txDuration != Time::Min());
+    mpdu->GetHeader().SetDuration(
+        GetMuRtsDurationId(mpdu->GetSize(),
+                           protection->muRtsTxVector,
+                           txParams.m_txDuration,
+                           txParams.m_acknowledgment->acknowledgmentTime));
+
+    // Get the TXVECTOR used by one station to send the CTS response. This is used
+    // to compute the preamble duration, so it does not matter which station we choose
+    WifiTxVector ctsTxVector =
+        GetCtsTxVectorAfterMuRts(protection->muRts, protection->muRts.begin()->GetAid12());
+
+    // After transmitting an MU-RTS frame, the STA shall wait for a CTSTimeout interval of
+    // aSIFSTime + aSlotTime + aRxPHYStartDelay (Sec. 27.2.5.2 of 802.11ax D3.0).
+    // aRxPHYStartDelay equals the time to transmit the PHY header.
+    Time timeout = m_phy->CalculateTxDuration(mpdu->GetSize(),
+                                              protection->muRtsTxVector,
+                                              m_phy->GetPhyBand()) +
+                   m_phy->GetSifs() + m_phy->GetSlot() +
+                   m_phy->CalculatePhyPreambleAndHeaderDuration(ctsTxVector);
+
+    NS_ASSERT(!m_txTimer.IsRunning());
+    m_txTimer.Set(WifiTxTimer::WAIT_CTS_AFTER_MU_RTS,
+                  timeout,
+                  &HeFrameExchangeManager::CtsAfterMuRtsTimeout,
+                  this,
+                  mpdu,
+                  protection->muRtsTxVector);
+    m_channelAccessManager->NotifyCtsTimeoutStartNow(timeout);
+
+    ForwardMpduDown(mpdu, protection->muRtsTxVector);
+}
+
+void
+HeFrameExchangeManager::CtsAfterMuRtsTimeout(Ptr<WifiMpdu> muRts, const WifiTxVector& txVector)
+{
+    NS_LOG_FUNCTION(this << *muRts << txVector);
+
+    NS_ASSERT(!m_psduMap.empty());
+
+    for (const auto& psdu : m_psduMap)
+    {
+        for (const auto& mpdu : *PeekPointer(psdu.second))
+        {
+            if (mpdu->IsQueued())
+            {
+                mpdu->ResetInFlight(m_linkId);
+            }
+        }
+    }
+
+    // NOTE Implementation of QSRC[AC] and QLRC[AC] should be improved...
+    const auto& hdr = m_psduMap.cbegin()->second->GetHeader(0);
+    if (!hdr.GetAddr1().IsGroup())
+    {
+        GetWifiRemoteStationManager()->ReportRtsFailed(hdr);
+    }
+
+    if (!hdr.GetAddr1().IsGroup() &&
+        !GetWifiRemoteStationManager()->NeedRetransmission(*m_psduMap.cbegin()->second->begin()))
+    {
+        NS_LOG_DEBUG("Missed CTS, discard MPDUs");
+        GetWifiRemoteStationManager()->ReportFinalRtsFailed(hdr);
+        for (const auto& psdu : m_psduMap)
+        {
+            // Dequeue the MPDUs if they are stored in a queue
+            DequeuePsdu(psdu.second);
+            for (const auto& mpdu : *PeekPointer(psdu.second))
+            {
+                NotifyPacketDiscarded(mpdu);
+            }
+        }
+        m_edca->ResetCw(m_linkId);
+    }
+    else
+    {
+        NS_LOG_DEBUG("Missed CTS, retransmit MPDUs");
+        m_edca->UpdateFailedCw(m_linkId);
+    }
+    // Make the sequence numbers of the MPDUs available again if the MPDUs have never
+    // been transmitted, both in case the MPDUs have been discarded and in case the
+    // MPDUs have to be transmitted (because a new sequence number is assigned to
+    // MPDUs that have never been transmitted and are selected for transmission)
+    for (const auto& [staId, psdu] : m_psduMap)
+    {
+        ReleaseSequenceNumbers(psdu);
+    }
+    m_psduMap.clear();
+    TransmissionFailed();
+}
+
 Ptr<WifiPsdu>
 HeFrameExchangeManager::GetPsduTo(Mac48Address to, const WifiPsduMap& psduMap)
 {
@@ -318,7 +509,7 @@
                 uint8_t tid = *tids.begin();
 
                 NS_ASSERT(m_edca);
-                m_edca->ScheduleBar(
+                m_edca->GetBaManager()->ScheduleBar(
                     m_mac->GetQosTxop(tid)->PrepareBlockAckRequest(psdu.second->GetAddr1(), tid));
             }
         }
@@ -379,7 +570,7 @@
             m_trigVector.SetLength(acknowledgment->ulLength);
 
             NS_ASSERT(m_edca);
-            m_edca->ScheduleBar(PrepareMuBar(m_trigVector, recipients));
+            m_edca->GetBaManager()->ScheduleMuBar(PrepareMuBar(m_trigVector, recipients));
         }
         else
         {
@@ -417,7 +608,8 @@
             ForwardPsduDown(triggerPsdu, acknowledgment->muBarTxVector);
 
             // Pass TRIGVECTOR to HE PHY (equivalent to PHY-TRIGGER.request primitive)
-            auto hePhy = StaticCast<HePhy>(m_phy->GetPhyEntity(WIFI_MOD_CLASS_HE));
+            auto hePhy =
+                StaticCast<HePhy>(m_phy->GetPhyEntity(responseTxVector->GetModulationClass()));
             hePhy->SetTrigVector(m_trigVector, timeout);
 
             return;
@@ -475,8 +667,8 @@
     else if (m_txParams.m_acknowledgment->method == WifiAcknowledgment::UL_MU_MULTI_STA_BA)
     {
         // the PSDU map being sent must contain a (Basic) Trigger Frame
-        NS_ASSERT(m_psduMap.size() == 1 && m_psduMap.begin()->first == SU_STA_ID &&
-                  (mpdu = *m_psduMap.begin()->second->begin())->GetHeader().IsTrigger());
+        NS_ASSERT(IsTrigger(m_psduMap));
+        mpdu = *m_psduMap.begin()->second->begin();
 
         WifiUlMuMultiStaBa* acknowledgment =
             static_cast<WifiUlMuMultiStaBa*>(m_txParams.m_acknowledgment.get());
@@ -494,28 +686,17 @@
         acknowledgment->stationsReceivingMultiStaBa.clear();
         acknowledgment->baType.m_bitmapLen.clear();
 
-        // Add a SIFS and the TB PPDU duration to the acknowledgment time of the
-        // Trigger Frame, so that its Duration/ID is correctly computed
-        NS_ASSERT(m_muScheduler);
-        Time tbPpduDuration = HePhy::ConvertLSigLengthToHeTbPpduDuration(
-            m_muScheduler->GetUlMuInfo().trigger.GetUlLength(),
-            acknowledgment->tbPpduTxVector,
-            m_phy->GetPhyBand());
-        acknowledgment->acknowledgmentTime += m_mac->GetWifiPhy()->GetSifs() + tbPpduDuration;
-
         timerType = WifiTxTimer::WAIT_TB_PPDU_AFTER_BASIC_TF;
         responseTxVector = &acknowledgment->tbPpduTxVector;
-        m_trigVector = GetTrigVector(m_muScheduler->GetUlMuInfo().trigger);
+        m_trigVector = GetTrigVector(m_muScheduler->GetUlMuInfo(m_linkId).trigger);
     }
     /*
      * BSRP Trigger Frame
      */
     else if (m_txParams.m_acknowledgment->method == WifiAcknowledgment::NONE &&
-             !m_txParams.m_txVector.IsUlMu() && m_psduMap.size() == 1 &&
-             m_psduMap.begin()->first == SU_STA_ID &&
-             (*m_psduMap.begin()->second->begin())->GetHeader().IsTrigger())
+             !m_txParams.m_txVector.IsUlMu() && IsTrigger(m_psduMap))
     {
-        CtrlTriggerHeader& trigger = m_muScheduler->GetUlMuInfo().trigger;
+        CtrlTriggerHeader& trigger = m_muScheduler->GetUlMuInfo(m_linkId).trigger;
         NS_ASSERT(trigger.IsBsrp());
         NS_ASSERT(m_apMac);
 
@@ -524,24 +705,15 @@
 
         for (const auto& userInfo : trigger)
         {
-            auto staIt = m_apMac->GetStaList().find(userInfo.GetAid12());
-            NS_ASSERT(staIt != m_apMac->GetStaList().end());
+            auto staIt = m_apMac->GetStaList(m_linkId).find(userInfo.GetAid12());
+            NS_ASSERT(staIt != m_apMac->GetStaList(m_linkId).end());
             m_staExpectTbPpduFrom.insert(staIt->second);
         }
 
-        // Add a SIFS and the TB PPDU duration to the acknowledgment time of the
-        // Trigger Frame, so that its Duration/ID is correctly computed
-        WifiNoAck* acknowledgment = static_cast<WifiNoAck*>(m_txParams.m_acknowledgment.get());
-        txVector = trigger.GetHeTbTxVector(trigger.begin()->GetAid12());
-        acknowledgment->acknowledgmentTime +=
-            m_mac->GetWifiPhy()->GetSifs() +
-            HePhy::ConvertLSigLengthToHeTbPpduDuration(trigger.GetUlLength(),
-                                                       txVector,
-                                                       m_phy->GetPhyBand());
-
         timerType = WifiTxTimer::WAIT_QOS_NULL_AFTER_BSRP_TF;
+        txVector = trigger.GetHeTbTxVector(trigger.begin()->GetAid12());
         responseTxVector = &txVector;
-        m_trigVector = GetTrigVector(m_muScheduler->GetUlMuInfo().trigger);
+        m_trigVector = GetTrigVector(m_muScheduler->GetUlMuInfo(m_linkId).trigger);
     }
     /*
      * TB PPDU solicited by a Basic Trigger Frame
@@ -673,7 +845,7 @@
         timerType == WifiTxTimer::WAIT_QOS_NULL_AFTER_BSRP_TF)
     {
         // Pass TRIGVECTOR to HE PHY (equivalent to PHY-TRIGGER.request primitive)
-        auto hePhy = StaticCast<HePhy>(m_phy->GetPhyEntity(WIFI_MOD_CLASS_HE));
+        auto hePhy = StaticCast<HePhy>(m_phy->GetPhyEntity(responseTxVector->GetModulationClass()));
         hePhy->SetTrigVector(m_trigVector, m_txTimer.GetDelayLeft());
     }
     else if (timerType == WifiTxTimer::NOT_RUNNING && m_txParams.m_txVector.IsUlMu())
@@ -688,9 +860,9 @@
 {
     NS_LOG_FUNCTION(this << psduMap << txVector);
 
-    if (txVector.IsDlMu())
+    if (ns3::IsDlMu(txVector.GetPreambleType()))
     {
-        auto hePhy = StaticCast<HePhy>(m_phy->GetPhyEntity(WIFI_MOD_CLASS_HE));
+        auto hePhy = StaticCast<HePhy>(m_phy->GetPhyEntity(txVector.GetModulationClass()));
         auto sigBMode = hePhy->GetSigBMode(txVector);
         txVector.SetSigBMode(sigBMode);
     }
@@ -751,7 +923,7 @@
     else
     {
         NS_ASSERT(m_apMac);
-        rxAddress = m_apMac->GetStaList().at(recipients.begin()->first);
+        rxAddress = m_apMac->GetStaList(m_linkId).at(recipients.begin()->first);
     }
 
     WifiMacHeader hdr;
@@ -767,6 +939,38 @@
 }
 
 void
+HeFrameExchangeManager::CalculateProtectionTime(WifiProtection* protection) const
+{
+    NS_LOG_FUNCTION(this << protection);
+    NS_ASSERT(protection != nullptr);
+
+    if (protection->method == WifiProtection::MU_RTS_CTS)
+    {
+        WifiMuRtsCtsProtection* muRtsCtsProtection =
+            static_cast<WifiMuRtsCtsProtection*>(protection);
+
+        // Get the TXVECTOR used by one station to send the CTS response. This is used
+        // to compute the TX duration, so it does not matter which station we choose
+        WifiTxVector ctsTxVector =
+            GetCtsTxVectorAfterMuRts(muRtsCtsProtection->muRts,
+                                     muRtsCtsProtection->muRts.begin()->GetAid12());
+
+        uint32_t muRtsSize = WifiMacHeader(WIFI_MAC_CTL_TRIGGER).GetSize() +
+                             muRtsCtsProtection->muRts.GetSerializedSize() + WIFI_MAC_FCS_LENGTH;
+        muRtsCtsProtection->protectionTime =
+            m_phy->CalculateTxDuration(muRtsSize,
+                                       muRtsCtsProtection->muRtsTxVector,
+                                       m_phy->GetPhyBand()) +
+            m_phy->CalculateTxDuration(GetCtsSize(), ctsTxVector, m_phy->GetPhyBand()) +
+            2 * m_phy->GetSifs();
+    }
+    else
+    {
+        VhtFrameExchangeManager::CalculateProtectionTime(protection);
+    }
+}
+
+void
 HeFrameExchangeManager::CalculateAcknowledgmentTime(WifiAcknowledgment* acknowledgment) const
 {
     NS_LOG_FUNCTION(this << acknowledgment);
@@ -929,6 +1133,50 @@
     }
 }
 
+WifiMode
+HeFrameExchangeManager::GetCtsModeAfterMuRts() const
+{
+    // The CTS frame sent in response to an MU-RTS Trigger frame shall be carried in a non-HT or
+    // non-HT duplicate PPDU (see Clause 17) with a 6 Mb/s rate (Sec. 26.2.6.3 of 802.11ax-2021)
+    return m_phy->GetPhyBand() == WIFI_PHY_BAND_2_4GHZ ? ErpOfdmPhy::GetErpOfdmRate6Mbps()
+                                                       : OfdmPhy::GetOfdmRate6Mbps();
+}
+
+WifiTxVector
+HeFrameExchangeManager::GetCtsTxVectorAfterMuRts(const CtrlTriggerHeader& trigger,
+                                                 uint16_t staId) const
+{
+    NS_LOG_FUNCTION(this << trigger << staId);
+
+    auto userInfoIt = trigger.FindUserInfoWithAid(staId);
+    NS_ASSERT_MSG(userInfoIt != trigger.end(), "User Info field for AID=" << staId << " not found");
+    uint16_t bw = 0;
+
+    if (uint8_t ru = userInfoIt->GetMuRtsRuAllocation(); ru < 65)
+    {
+        bw = 20;
+    }
+    else if (ru < 67)
+    {
+        bw = 40;
+    }
+    else if (ru == 67)
+    {
+        bw = 80;
+    }
+    else
+    {
+        NS_ASSERT(ru == 68);
+        bw = 160;
+    }
+
+    auto txVector = GetWifiRemoteStationManager()->GetCtsTxVector(m_bssid, GetCtsModeAfterMuRts());
+    // set the channel width of the CTS TXVECTOR according to the allocated RU
+    txVector.SetChannelWidth(bw);
+
+    return txVector;
+}
+
 Time
 HeFrameExchangeManager::GetTxDuration(uint32_t ppduPayloadSize,
                                       Mac48Address receiver,
@@ -974,8 +1222,7 @@
     NS_LOG_FUNCTION(this << psduMap << staMissedTbPpduFrom->size() << nSolicitedStations);
 
     NS_ASSERT(psduMap);
-    NS_ASSERT(psduMap->size() == 1 && psduMap->begin()->first == SU_STA_ID &&
-              psduMap->begin()->second->GetHeader(0).IsTrigger());
+    NS_ASSERT(IsTrigger(*psduMap));
 
     // This method is called if some station(s) did not send a TB PPDU
     NS_ASSERT(!staMissedTbPpduFrom->empty());
@@ -1028,7 +1275,12 @@
         resetCw = true;
     }
 
-    m_triggerFrame = nullptr; // this is strictly needed for DL_MU_TF_MU_BAR only
+    if (m_triggerFrame)
+    {
+        // this is strictly needed for DL_MU_TF_MU_BAR only
+        DequeueMpdu(m_triggerFrame);
+        m_triggerFrame = nullptr;
+    }
 
     for (const auto& sta : *staMissedBlockAckFrom)
     {
@@ -1102,7 +1354,8 @@
         {
             if (mpdu->IsQueued())
             {
-                mpdu->GetHeader().SetRetry();
+                m_mac->GetTxopQueue(mpdu->GetQueueAc())->GetOriginal(mpdu)->GetHeader().SetRetry();
+                mpdu->ResetInFlight(m_linkId);
             }
         }
     }
@@ -1136,16 +1389,16 @@
 HeFrameExchangeManager::GetTrigVector(const CtrlTriggerHeader& trigger) const
 {
     WifiTxVector v;
-    v.SetPreambleType(WifiPreamble::WIFI_PREAMBLE_HE_TB);
+    v.SetPreambleType(trigger.GetVariant() == TriggerFrameVariant::HE ? WIFI_PREAMBLE_HE_TB
+                                                                      : WIFI_PREAMBLE_EHT_TB);
     v.SetChannelWidth(trigger.GetUlBandwidth());
     v.SetGuardInterval(trigger.GetGuardInterval());
     v.SetLength(trigger.GetUlLength());
     for (const auto& userInfoField : trigger)
     {
-        v.SetHeMuUserInfo(userInfoField.GetAid12(),
-                          {userInfoField.GetRuAllocation(),
-                           HePhy::GetHeMcs(userInfoField.GetUlMcs()),
-                           userInfoField.GetNss()});
+        v.SetHeMuUserInfo(
+            userInfoField.GetAid12(),
+            {userInfoField.GetRuAllocation(), userInfoField.GetUlMcs(), userInfoField.GetNss()});
     }
     return v;
 }
@@ -1193,10 +1446,12 @@
      *
      * Refer to section 27.3.14.2 (Power pre-correction) of 802.11ax Draft 4.0 for more details.
      */
+    auto optRssi = GetMostRecentRssi(triggerSender);
+    NS_ASSERT(optRssi);
     int8_t pathLossDb =
         trigger.GetApTxPower() -
-        static_cast<int8_t>(GetWifiRemoteStationManager()->GetMostRecentRssi(
-            triggerSender)); // cast RSSI to be on equal footing with AP Tx power information
+        static_cast<int8_t>(
+            *optRssi); // cast RSSI to be on equal footing with AP Tx power information
     double reqTxPowerDbm = static_cast<double>(userInfoIt->GetUlTargetRssi() + pathLossDb);
 
     // Convert the transmit power to a power level
@@ -1229,6 +1484,12 @@
     return v;
 }
 
+std::optional<double>
+HeFrameExchangeManager::GetMostRecentRssi(const Mac48Address& address) const
+{
+    return GetWifiRemoteStationManager()->GetMostRecentRssi(address);
+}
+
 void
 HeFrameExchangeManager::SetTargetRssi(CtrlTriggerHeader& trigger) const
 {
@@ -1239,11 +1500,12 @@
         m_phy->GetPowerDbm(GetWifiRemoteStationManager()->GetDefaultTxPowerLevel())));
     for (auto& userInfo : trigger)
     {
-        const auto staList = m_apMac->GetStaList();
+        const auto staList = m_apMac->GetStaList(m_linkId);
         auto itAidAddr = staList.find(userInfo.GetAid12());
         NS_ASSERT(itAidAddr != staList.end());
-        int8_t rssi = static_cast<int8_t>(
-            GetWifiRemoteStationManager()->GetMostRecentRssi(itAidAddr->second));
+        auto optRssi = GetMostRecentRssi(itAidAddr->second);
+        NS_ASSERT(optRssi);
+        int8_t rssi = static_cast<int8_t>(*optRssi);
         rssi = (rssi >= -20)
                    ? -20
                    : ((rssi <= -110) ? -110 : rssi); // cap so as to keep within [-110; -20] dBm
@@ -1252,9 +1514,68 @@
 }
 
 void
-HeFrameExchangeManager::SendMultiStaBlockAck(const WifiTxParameters& txParams)
+HeFrameExchangeManager::PostProcessFrame(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector)
 {
-    NS_LOG_FUNCTION(this << &txParams);
+    NS_LOG_FUNCTION(this << psdu << txVector);
+
+    auto txVectorCopy = txVector;
+
+    if (psdu->GetNMpdus() == 1 && psdu->GetHeader(0).IsTrigger())
+    {
+        CtrlTriggerHeader trigger;
+        psdu->GetPayload(0)->PeekHeader(trigger);
+        if (trigger.IsMuRts())
+        {
+            const WifiMacHeader& muRts = psdu->GetHeader(0);
+            // A station receiving an MU-RTS behaves just like as if it received an RTS.
+            // Determine whether the MU-RTS is addressed to this station or not and
+            // prepare an "equivalent" RTS frame so that we can reuse the UpdateNav()
+            // and SetTxopHolder() methods of the parent classes
+            WifiMacHeader rts;
+            rts.SetType(WIFI_MAC_CTL_RTS);
+            rts.SetDsNotFrom();
+            rts.SetDsNotTo();
+            rts.SetDuration(muRts.GetDuration());
+            rts.SetAddr2(muRts.GetAddr2());
+            if (m_staMac != nullptr && m_staMac->IsAssociated() &&
+                muRts.GetAddr2() == m_bssid // sent by the AP this STA is associated with
+                && trigger.FindUserInfoWithAid(m_staMac->GetAssociationId()) != trigger.end())
+            {
+                // the MU-RTS is addressed to this station
+                rts.SetAddr1(m_self);
+            }
+            else
+            {
+                rts.SetAddr1(muRts.GetAddr2()); // an address different from that of this station
+            }
+            psdu = Create<const WifiPsdu>(Create<Packet>(), rts);
+            // The duration of the NAV reset timeout has to take into account that the CTS
+            // response is sent using the 6 Mbps data rate
+            txVectorCopy =
+                GetWifiRemoteStationManager()->GetCtsTxVector(m_bssid, GetCtsModeAfterMuRts());
+        }
+    }
+    VhtFrameExchangeManager::PostProcessFrame(psdu, txVectorCopy);
+}
+
+void
+HeFrameExchangeManager::SendCtsAfterMuRts(const WifiMacHeader& muRtsHdr,
+                                          const CtrlTriggerHeader& trigger,
+                                          double muRtsSnr)
+{
+    NS_LOG_FUNCTION(this << muRtsHdr << trigger << muRtsSnr);
+
+    NS_ASSERT(m_staMac != nullptr && m_staMac->IsAssociated());
+    WifiTxVector ctsTxVector = GetCtsTxVectorAfterMuRts(trigger, m_staMac->GetAssociationId());
+    ctsTxVector.SetTriggerResponding(true);
+
+    DoSendCtsAfterRts(muRtsHdr, ctsTxVector, muRtsSnr);
+}
+
+void
+HeFrameExchangeManager::SendMultiStaBlockAck(const WifiTxParameters& txParams, Time durationId)
+{
+    NS_LOG_FUNCTION(this << &txParams << durationId.As(Time::US));
 
     NS_ASSERT(m_apMac);
     NS_ASSERT(txParams.m_acknowledgment &&
